use futures::Stream;
use tokio::io::AsyncBufRead;

use crate::{
    element::{Element, Name, Namespace},
    error::Error,
};

/// streaming reader that tracks depth and available namespaces at current depth
pub struct Reader<R> {
    stream: R,
    // holds which tags we are in atm over depth
    depth: Vec<Name>,
    namespaces: Vec<(usize, Namespace)>,
}

impl<R> Reader<R>
where
    R: AsyncBufRead,
{
    // pub async fn read(&self) -> Result<impl From<Element>, Error> {
    // let buf = self.stream.poll_fill_buf().await?;
    // todo!()
    // }
    // pub async fn read_start(&self) -> Result<impl From<Element>, Error> {
    //     todo!()
    // }
    // pub async fn read_end(&self) -> Result<(), Error> {
    //     todo!()
    // }
}

// impl<R: AsyncBufRead> Stream for Reader<R> {
//     type Item = impl From<Element>;

//     async fn poll_next(
//         self: std::pin::Pin<&mut Self>,
//         cx: &mut std::task::Context<'_>,
//     ) -> std::task::Poll<Option<Self::Item>> {
//         todo!()
//     }
// }
